#include "EsoAcsammm_Header.hpp"
// ++++++++++++++++++++++++++++++++++
// + Code generated by dcc 1.0      +
// ++++++++++++++++++++++++++++++++++
void t1_res_block_0(double* yy, double* t1_yy, double* der_x, double* t1_der_x, double* x, double* t1_x, double* p, double* t1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c, int& n_yy_ind, int* yy_ind, int& i_E_start, int& i_E_end)
#pragma ad indep x t1_x p t1_p
#pragma ad dep yy t1_yy
{
   int i_E=0; 
   int i_C=0; 
   int i__=0; 
   int j__=0; 
   int k__=0; 
   int m__=0; 
   int r_i=0; 
   int r_j=0; 
   int i_a=0; 
   int i_b=0; 
   int i_loop=0; 
   int i__switch=0; 
   int i__start=0; 
   int i__end=0; 
   int i__step=0; 
   int while_end=0; 
   int i_cont=0; 
   int j_cont=0; 
   int k_cont=0; 
   double var_alpha=0; 
   double t1_var_alpha=0; 
   double var_k1=0; 
   double t1_var_k1=0; 
   double var_k2=0; 
   double t1_var_k2=0; 
   double var_m=0; 
   double t1_var_m=0; 
   double par_a=0; 
   double t1_par_a=0; 
   double var_s=0; 
   double t1_var_s=0; 
   double der_var_s=0; 
   double t1_der_var_s=0; 
   double var_t=0; 
   double t1_var_t=0; 
   double der_var_t=0; 
   double t1_der_var_t=0; 
   double var_v=0; 
   double t1_var_v=0; 
   double der_var_v=0; 
   double t1_der_var_v=0; 
   double var_obj=0; 
   double t1_var_obj=0; 
   double der_var_obj=0; 
   double t1_der_var_obj=0; 
   double var_deriv=0; 
   double t1_var_deriv=0; 
   double der_var_deriv=0; 
   double t1_der_var_deriv=0; 
   double var_div0=0; 
   double t1_var_div0=0; 
   double var_tanh1=0; 
   double t1_var_tanh1=0; 
   double var_i_expr=0; 
   double t1_var_i_expr=0; 
   int i_i=0; 
   int i_j=0; 
   int i_z=0; 
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double v1_2=0; 
   double t1_v1_2=0; 
   double v1_3=0; 
   double t1_v1_3=0; 
   double v1_4=0; 
   double t1_v1_4=0; 
   double v1_5=0; 
   double t1_v1_5=0; 
   double v1_6=0; 
   double t1_v1_6=0; 
   double v1_7=0; 
   double t1_v1_7=0; 
   double v1_8=0; 
   double t1_v1_8=0; 
   double v1_9=0; 
   double t1_v1_9=0; 
   double v1_10=0; 
   double t1_v1_10=0; 
   double v1_11=0; 
   double t1_v1_11=0; 
   double v1_12=0; 
   double t1_v1_12=0; 
   double v1_13=0; 
   double t1_v1_13=0; 
   double v1_14=0; 
   double t1_v1_14=0; 
   t1_v1_0=0;  // TLM constant reference
   v1_0=0.36;  // SAC constant reference
   t1_var_alpha=t1_v1_0; // TLM =
   var_alpha=v1_0; // SAC =
   t1_v1_0=0;  // TLM constant reference
   v1_0=15;  // SAC constant reference
   t1_var_k1=t1_v1_0; // TLM =
   var_k1=v1_0; // SAC =
   t1_v1_0=0;  // TLM constant reference
   v1_0=1;  // SAC constant reference
   t1_var_k2=t1_v1_0; // TLM =
   var_k2=v1_0; // SAC =
   t1_v1_0=0;  // TLM constant reference
   v1_0=1000;  // SAC constant reference
   t1_var_m=t1_v1_0; // TLM =
   var_m=v1_0; // SAC =
   t1_v1_0=t1_p[0]; // TLM array memory reference
   v1_0=p[0]; // SAC array memory reference
   t1_par_a=t1_v1_0; // TLM =
   par_a=v1_0; // SAC =
   t1_v1_0=t1_x[0]; // TLM array memory reference
   v1_0=x[0]; // SAC array memory reference
   t1_var_s=t1_v1_0; // TLM =
   var_s=v1_0; // SAC =
   t1_v1_0=t1_der_x[0]; // TLM array memory reference
   v1_0=der_x[0]; // SAC array memory reference
   t1_der_var_s=t1_v1_0; // TLM =
   der_var_s=v1_0; // SAC =
   t1_v1_0=t1_x[1]; // TLM array memory reference
   v1_0=x[1]; // SAC array memory reference
   t1_var_t=t1_v1_0; // TLM =
   var_t=v1_0; // SAC =
   t1_v1_0=t1_der_x[1]; // TLM array memory reference
   v1_0=der_x[1]; // SAC array memory reference
   t1_der_var_t=t1_v1_0; // TLM =
   der_var_t=v1_0; // SAC =
   t1_v1_0=t1_x[2]; // TLM array memory reference
   v1_0=x[2]; // SAC array memory reference
   t1_var_v=t1_v1_0; // TLM =
   var_v=v1_0; // SAC =
   t1_v1_0=t1_der_x[2]; // TLM array memory reference
   v1_0=der_x[2]; // SAC array memory reference
   t1_der_var_v=t1_v1_0; // TLM =
   der_var_v=v1_0; // SAC =
   t1_v1_0=t1_x[3]; // TLM array memory reference
   v1_0=x[3]; // SAC array memory reference
   t1_var_obj=t1_v1_0; // TLM =
   var_obj=v1_0; // SAC =
   t1_v1_0=t1_der_x[3]; // TLM array memory reference
   v1_0=der_x[3]; // SAC array memory reference
   t1_der_var_obj=t1_v1_0; // TLM =
   der_var_obj=v1_0; // SAC =
   t1_v1_0=t1_x[4]; // TLM array memory reference
   v1_0=x[4]; // SAC array memory reference
   t1_var_deriv=t1_v1_0; // TLM =
   var_deriv=v1_0; // SAC =
   t1_v1_0=t1_der_x[4]; // TLM array memory reference
   v1_0=der_x[4]; // SAC array memory reference
   t1_der_var_deriv=t1_v1_0; // TLM =
   der_var_deriv=v1_0; // SAC =
   // nonfloat assignment
   i_E=i_E_start;
   while (i_E<i_E_end) {
      // nonfloat assignment
      i__switch=yy_ind[i_E];
      switch (i__switch) {
         case 0: {
            t1_v1_0=t1_der_var_s; // TLM scalar memory reference
            v1_0=der_var_s; // SAC scalar memory reference
            t1_v1_1=t1_var_v; // TLM scalar memory reference
            v1_1=var_v; // SAC scalar memory reference
            t1_v1_2=t1_v1_1; // TLM ()
            v1_2=v1_1; // SAC ()
            t1_v1_3=t1_v1_0-t1_v1_2; // TLM -
            v1_3=v1_0-v1_2; // SAC -
            t1_yy[i_E]=t1_v1_3; // TLM =
            yy[i_E]=v1_3; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 1: {
            t1_acs_div(var_v,t1_var_v,var_m,t1_var_m,var_div0,t1_var_div0);
            t1_v1_0=t1_der_var_v; // TLM scalar memory reference
            v1_0=der_var_v; // SAC scalar memory reference
            t1_v1_1=t1_par_a; // TLM scalar memory reference
            v1_1=par_a; // SAC scalar memory reference
            t1_v1_2=t1_var_alpha; // TLM scalar memory reference
            v1_2=var_alpha; // SAC scalar memory reference
            t1_v1_3=t1_var_v; // TLM scalar memory reference
            v1_3=var_v; // SAC scalar memory reference
            t1_v1_4=v1_3*t1_v1_2+v1_2*t1_v1_3; // TLM *
            v1_4=v1_2*v1_3; // SAC *
            t1_v1_5=t1_var_div0; // TLM scalar memory reference
            v1_5=var_div0; // SAC scalar memory reference
            t1_v1_6=v1_5*t1_v1_4+v1_4*t1_v1_5; // TLM *
            v1_6=v1_4*v1_5; // SAC *
            t1_v1_7=t1_v1_1-t1_v1_6; // TLM -
            v1_7=v1_1-v1_6; // SAC -
            t1_v1_8=t1_v1_7; // TLM ()
            v1_8=v1_7; // SAC ()
            t1_v1_9=t1_v1_0-t1_v1_8; // TLM -
            v1_9=v1_0-v1_8; // SAC -
            t1_yy[i_E]=t1_v1_9; // TLM =
            yy[i_E]=v1_9; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 2: {
            t1_v1_0=t1_der_var_t; // TLM scalar memory reference
            v1_0=der_var_t; // SAC scalar memory reference
            t1_v1_1=0;  // TLM constant reference
            v1_1=1;  // SAC constant reference
            t1_v1_2=t1_v1_1; // TLM ()
            v1_2=v1_1; // SAC ()
            t1_v1_3=t1_v1_0-t1_v1_2; // TLM -
            v1_3=v1_0-v1_2; // SAC -
            t1_yy[i_E]=t1_v1_3; // TLM =
            yy[i_E]=v1_3; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 3: {
            t1_v1_0=t1_der_var_obj; // TLM scalar memory reference
            v1_0=der_var_obj; // SAC scalar memory reference
            t1_v1_1=t1_var_deriv; // TLM scalar memory reference
            v1_1=var_deriv; // SAC scalar memory reference
            t1_v1_2=t1_v1_1; // TLM ()
            v1_2=v1_1; // SAC ()
            t1_v1_3=t1_v1_0-t1_v1_2; // TLM -
            v1_3=v1_0-v1_2; // SAC -
            t1_yy[i_E]=t1_v1_3; // TLM =
            yy[i_E]=v1_3; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
         case 4: {
            t1_v1_0=t1_var_m; // TLM scalar memory reference
            v1_0=var_m; // SAC scalar memory reference
            t1_v1_1=t1_par_a; // TLM scalar memory reference
            v1_1=par_a; // SAC scalar memory reference
            t1_v1_2=v1_1*t1_v1_0+v1_0*t1_v1_1; // TLM *
            v1_2=v1_0*v1_1; // SAC *
            t1_var_i_expr=t1_v1_2; // TLM =
            var_i_expr=v1_2; // SAC =
            t1_acs_tanh(var_i_expr,t1_var_i_expr,var_tanh1,t1_var_tanh1);
            t1_v1_0=t1_var_deriv; // TLM scalar memory reference
            v1_0=var_deriv; // SAC scalar memory reference
            t1_v1_1=t1_var_k2; // TLM scalar memory reference
            v1_1=var_k2; // SAC scalar memory reference
            t1_v1_2=0;  // TLM constant reference
            v1_2=0.5;  // SAC constant reference
            t1_v1_3=t1_var_k1; // TLM scalar memory reference
            v1_3=var_k1; // SAC scalar memory reference
            t1_v1_4=v1_3*t1_v1_2+v1_2*t1_v1_3; // TLM *
            v1_4=v1_2*v1_3; // SAC *
            t1_v1_5=t1_par_a; // TLM scalar memory reference
            v1_5=par_a; // SAC scalar memory reference
            t1_v1_6=v1_5*t1_v1_4+v1_4*t1_v1_5; // TLM *
            v1_6=v1_4*v1_5; // SAC *
            t1_v1_7=0;  // TLM constant reference
            v1_7=1;  // SAC constant reference
            t1_v1_8=t1_var_tanh1; // TLM scalar memory reference
            v1_8=var_tanh1; // SAC scalar memory reference
            t1_v1_9=t1_v1_7+t1_v1_8; // TLM +
            v1_9=v1_7+v1_8; // SAC +
            t1_v1_10=t1_v1_9; // TLM ()
            v1_10=v1_9; // SAC ()
            t1_v1_11=v1_10*t1_v1_6+v1_6*t1_v1_10; // TLM *
            v1_11=v1_6*v1_10; // SAC *
            t1_v1_12=t1_v1_1+t1_v1_11; // TLM +
            v1_12=v1_1+v1_11; // SAC +
            t1_v1_13=t1_v1_12; // TLM ()
            v1_13=v1_12; // SAC ()
            t1_v1_14=t1_v1_0-t1_v1_13; // TLM -
            v1_14=v1_0-v1_13; // SAC -
            t1_yy[i_E]=t1_v1_14; // TLM =
            yy[i_E]=v1_14; // SAC =
            // nonfloat assignment
            i_E=i_E+1;
            break;
         }
      }
   }
}
void t1_res_block(double* yy, double* t1_yy, double* der_x, double* t1_der_x, double* x, double* t1_x, double* p, double* t1_p, int* condit, int* lock, int* prev, int& n_x, int& n_p, int& n_c, int& n_yy_ind, int* yy_ind)
#pragma ad indep x t1_x p t1_p
#pragma ad dep yy t1_yy
{
   int i_E=0; 
   int i_E_end=5; 
   int i__start=0; 
   int i__end=0; 
   int i__switch=0; 
   double v1_0=0; 
   double t1_v1_0=0; 
   double v1_1=0; 
   double t1_v1_1=0; 
   double v1_2=0; 
   double t1_v1_2=0; 
   double v1_3=0; 
   double t1_v1_3=0; 
   while (i_E<n_yy_ind) {
      // nonfloat assignment
      i__switch=yy_ind[i_E];
      // nonfloat assignment
      i__start=0;
      // nonfloat assignment
      i__end=5;
      if ((i__switch>=i__start) && (i__switch<i__end)) {
         // nonfloat assignment
         i__end=i_E+1;
         t1_res_block_0(yy,t1_yy,der_x,t1_der_x,x,t1_x,p,t1_p,condit,lock,prev,n_x,n_p,n_c,n_yy_ind,yy_ind,i_E,i__end);
      }
      // nonfloat assignment
      i_E=i_E+1;
   }
}
